package
{
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.TimerEvent;
	import flash.system.Capabilities;
	import flash.system.MessageChannel;
	import flash.system.Worker;
	import flash.system.WorkerDomain;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.utils.ByteArray;
	import flash.utils.Timer;

	import starling.core.Starling;

	[SWF(frameRate = "60", backgroundColor = "#FFFFFF")]
	public class StarlingArrows extends flash.display.Sprite
	{

		//----------------------------------------------------------
		//
		//   Static Property 
		//
		//----------------------------------------------------------

		public static const FIRST_NUM:uint = 15000;
		public static const FIRST_NUM_DEBUG:uint = 3000;

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function StarlingArrows()
		{
			if (Worker.current.isPrimordial)
			{
				//ワーカー作成
				var ba:ByteArray = Workers.workers_ForceMapGenerator;
				worker = WorkerDomain.current.createWorker(ba);

				if (worker)
				{
					//メッセージチャンネル作成
					//子ワーカーに対するメッセージチャンネル作成
					toChild = Worker.current.createMessageChannel(worker);
					//メインワーカーに対するメッセージチャンネル作成
					toMain = worker.createMessageChannel(Worker.current);

					//共有プロパティに設定
					worker.setSharedProperty("toChild", toChild);
					worker.setSharedProperty("toMain", toMain);

					//ワーカースタート
					worker.start();

					//メインワーカーのメッセージチャンネルのイベント
					toMain.addEventListener(Event.CHANNEL_MESSAGE, toMain_channelMessageHandler);
				}

				// コンテンツスタート
				stage.align = StageAlign.TOP_LEFT;
				stage.scaleMode = StageScaleMode.NO_SCALE;
				stage.quality = StageQuality.LOW;
				mouseChildren = mouseEnabled = false;
				tabChildren = tabEnabled = false;

				Starling.handleLostContext = true;
				var mStarling:Starling = new Starling(StarlingPart, stage);
				mStarling.addEventListener("rootCreated", rootCreatedHandler);
				mStarling.showStats = true;
				mStarling.enableErrorChecking = false;
				mStarling.start();

				waitTimer = new Timer(50, 1);
				waitTimer.addEventListener(TimerEvent.TIMER_COMPLETE, waitTimer_completeHandler);
				stage.addEventListener(Event.RESIZE, resizeHandler);
				resizeHandler(null);

				stage.addEventListener(MouseEvent.RIGHT_CLICK, trace);
			}
			else
			{
			}

			var tf:TextField = new TextField();
			tf.autoSize = "left";
			tf.y = 30;
			tf.border = true;
			tf.defaultTextFormat = new TextFormat("Arial", 16, 0xFF0000, true);

			if (worker == null)
				tf.text = "It does not update force map, because your machine is not available to use Worker.\n";
			if (Capabilities.isDebugger)
				tf.text = "Your Flash Player is Debugger. The number of arrows is 3000. \n";
			if (tf.text.length > 0)
				addChild(tf);
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		private var stageH:int = 0;
		private var stageW:int = 0;
		private var toChild:MessageChannel;
		private var toMain:MessageChannel;
		private var waitTimer:Timer;
		private var worker:Worker;

		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------

		public function toMain_channelMessageHandler(e:Event):void
		{
			//メッセージチャンネルにメッセージがあるかどうか
			if (toMain.messageAvailable)
			{
				//メッセージチャンネルに受信
				var message:Array = toMain.receive();

				StarlingPart.instance.updateForceMap(message[0], message[1], message[2]);
			}
		}

		protected function resizeHandler(event:Event):void
		{
			waitTimer.stop();
			waitTimer.reset();
			waitTimer.start();
		}

		protected function waitTimer_completeHandler(event:TimerEvent):void
		{
			toChild.send([stage.stageWidth, stage.stageHeight]);
		}

		private function rootCreatedHandler(e:starling.events.Event):void
		{
			//------------------------ ここから
			// フォールバック用・・・ (PPAPIのFlash Player対策…
			stageW = stage.stageWidth;
			stageH = stage.stageHeight;
			var forceMap:BitmapData = new BitmapData(stageW, stageH, false, 0x0)
			forceMap.perlinNoise(forceMap.width, forceMap.height, 4, 0xFFFFFF * Math.random(), false, true, 1 + 2 + 4, false);
			StarlingPart.instance.updateForceMap(forceMap.getVector(forceMap.rect), stageW, stageH);
			//------------------------ ここまで
		}
	}
}

import flash.display.BitmapData;
import flash.display.Shape;
import flash.geom.Rectangle;
import flash.system.Capabilities;

import starling.core.Starling;
import starling.display.Image;
import starling.display.QuadBatch;
import starling.display.Sprite;
import starling.events.Event;
import starling.events.ResizeEvent;
import starling.textures.Texture;

internal final class StarlingPart extends Sprite
{

	//----------------------------------------------------------
	//
	//   Static Property 
	//
	//----------------------------------------------------------

	public static var instance:StarlingPart;
	private static const MAX:int = 8192;

	//----------------------------------------------------------
	//
	//   Constructor 
	//
	//----------------------------------------------------------

	public function StarlingPart()
	{
		instance = this;
		addEventListener(Event.ADDED_TO_STAGE, addedToStageHandler);
	}

	//----------------------------------------------------------
	//
	//   Property 
	//
	//----------------------------------------------------------

	private var first:Particle;

	private var forceMapList:Vector.<uint>;
	private var image:Image;
	private var quadBatchs:Vector.<QuadBatch>;

	private var rect:Rectangle = new Rectangle();
	private var stageH:int = 800;
	private var stageW:int = 800;

	//----------------------------------------------------------
	//
	//   Function 
	//
	//----------------------------------------------------------

	public function reset(numObj:uint):void
	{
		var i:int;

		if (quadBatchs)
		{
			for (i = 0; i < quadBatchs.length; i++)
			{
				quadBatchs[i].dispose();
				removeChild(quadBatchs[i]);
			}
		}

		var len:int = Math.ceil(numObj / MAX);
		quadBatchs = new Vector.<QuadBatch>();
		for (i = 0; i < len; i++)
		{
			quadBatchs[i] = new QuadBatch();
			addChild(quadBatchs[i]);
		}

		var old:Particle;
		for (i = 0; i < numObj; i++)
		{
			var p:Particle = new Particle();
			p.x = stageW * Math.random();
			p.y = stageH * Math.random();
			p.vx = 0;
			p.vy = 0;
			if (old)
				old.next = p;
			if (i == 0)
				first = p;
			old = p;
		}
	}

	public function updateForceMap(forceMapData:Vector.<uint>, stageW:int, stageH:int):void
	{
		var tempW:int = this.stageW;
		var tempH:int = this.stageH;

		this.forceMapList = forceMapData;
		this.forceMapList.fixed = true;
		this.stageW = stageW;
		this.stageH = stageH;

		if (tempW != stageW || tempH != stageH)
		{
			var p:Particle = first;
			while (p.next)
			{
				p.x = stageW * Math.random();
				p.y = stageH * Math.random();

				p = p.next;
			}
		}
	}

	private final function addedToStageHandler(event:Event):void
	{
		this.touchable = false;

		// 矢印をプレレンダリング
		var arrow:Shape = new Shape();
		arrow.graphics.beginFill(0xFFFFFF, 1);
		arrow.graphics.lineStyle(1, 0x0, 1);
		arrow.graphics.moveTo(2, 4);
		arrow.graphics.lineTo(8, 4);
		arrow.graphics.lineTo(8, 0);
		arrow.graphics.lineTo(20, 7);
		arrow.graphics.lineTo(8, 14);
		arrow.graphics.lineTo(8, 10);
		arrow.graphics.lineTo(2, 10);
		arrow.graphics.lineTo(2, 4);

		var bmd:BitmapData = new BitmapData(20, 14, true, 0x00000000);
		bmd.draw(arrow);
		var texture:Texture = Texture.fromBitmapData(bmd, false);

		image = new Image(texture);
		image.pivotX = image.width >> 1;
		image.pivotY = image.height >> 1;

		reset(Capabilities.isDebugger ? StarlingArrows.FIRST_NUM_DEBUG : StarlingArrows.FIRST_NUM);

		addEventListener(Event.ENTER_FRAME, enterFrameHandler);
		stage.addEventListener(ResizeEvent.RESIZE, resizeHandler);
	}

	private final function resizeHandler(e:ResizeEvent = null):void
	{
		// set rectangle dimensions for viewPort:
		rect.width = e.width;
		rect.height = e.height

		// resize the viewport:
		Starling.current.viewPort = rect;

		// assign the new stage width and height:
		stage.stageWidth = e.width;
		stage.stageHeight = e.height;
	}

	private final function enterFrameHandler(event:Event):void
	{
		if (!forceMapList)
			return;

		var p:Particle = first;
		var color:Number;
		var i:int;

		for (i = 0; i < quadBatchs.length; i++)
			quadBatchs[i].reset();

		var cnt:int = 0;
		while (p.next)
		{

			var px:int = p.x;
			var py:int = p.y;
			if (p.x < 0)
				px = 0;
			else if (p.x > stageW - 1)
				px = stageW - 1;
			if (p.y < 0)
				py = 0;
			else if (p.y > stageH - 1)
				py = stageH - 1;

			color = forceMapList[(px >> 0) + (py * stageW >> 0)]
			p.ax += ((color & 0xff) - 0x80) * .0002; // 青
			p.ay += ((color >> 8 & 0xff) - 0x80) * .0002; // 緑
			p.vx += p.ax;
			p.vy += p.ay;
			p.x += p.vx;
			p.y += p.vy;

			var rot:Number = +Math.atan2(p.vy, p.vx);
			p.rot = rot;
			p.ax *= .98;
			p.ay *= .98;
			p.vx *= .96;
			p.vy *= .96;

			var posX:Number = p.x;
			var posY:Number = p.y;

			(posX > stageW) ? p.x = 0 :
				(posX < 0) ? p.x = stageW : 0;
			(posY > stageH) ? p.y = 0 :
				(posY < 0) ? p.y = stageH : 0;

			image.x = p.x;
			image.y = p.y;
			image.rotation = p.rot;
			quadBatchs[cnt / MAX >> 0].addImage(image);

			p = p.next;
			cnt++;
		}
	}
}

internal final class Particle
{

	//----------------------------------------------------------
	//
	//   Constructor 
	//
	//----------------------------------------------------------

	public function Particle()
	{
	}

	//----------------------------------------------------------
	//
	//   Property 
	//
	//----------------------------------------------------------

	public var ax:Number = 0;
	public var ay:Number = 0;
	public var next:Particle;
	public var rot:Number = 0;
	public var vx:Number = 0;
	public var vy:Number = 0;
	public var x:Number = 0;
	public var y:Number = 0;
}
