package workers
{
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.system.MessageChannel;
	import flash.system.Worker;
	import flash.utils.Timer;

	[SWF(frameRate = "1")]
	public class ForceMapGenerator extends Sprite
	{

		//----------------------------------------------------------
		//
		//   Constructor 
		//
		//----------------------------------------------------------

		public function ForceMapGenerator()
		{
			if (Worker.current.isPrimordial)
			{
			}
			else
			{
				toChild = Worker.current.getSharedProperty("toChild");
				toMain = Worker.current.getSharedProperty("toMain");

				//メインワーカーのメッセージチャンネルのイベント
				toChild.addEventListener(Event.CHANNEL_MESSAGE, toChild_channelMessageHandler);

				var timer:Timer = new Timer(3500);
				timer.addEventListener(TimerEvent.TIMER, timerHandler);
				timer.start();
			}
		}

		//----------------------------------------------------------
		//
		//   Property 
		//
		//----------------------------------------------------------

		private var forceMap:BitmapData;
		private var offset:Array = [new Point(), new Point(), new Point()];
		private var randomSeed:uint = Math.floor(Math.random() * 0xFFFF);
		private var stageH:int = 1;
		private var stageW:int = 1;
		private var toChild:MessageChannel;
		private var toMain:MessageChannel;

		//----------------------------------------------------------
		//
		//   Function 
		//
		//----------------------------------------------------------

		protected function toChild_channelMessageHandler(event:Event):void
		{
			//メッセージチャンネルにメッセージがあるかどうか
			if (toChild.messageAvailable)
			{
				//メッセージチャンネルに受信
				var message:Array = toChild.receive();

				stageW = message[0];
				stageH = message[1];

				createForceMap();
				noiseForceMap();
				sendData();
			}
		}

		protected function timerHandler(event:TimerEvent):void
		{
			noiseForceMap();
			sendData();
		}

		private final function sendData():void
		{
			var message:Vector.<uint> = forceMap.getVector(forceMap.rect);
			toMain.send([message, stageW, stageH]);
		}

		private final function createForceMap():void
		{
			if (forceMap)
				forceMap.dispose();

			forceMap = new BitmapData(stageW, stageH, false, 0x000000);
		}

		private final function noiseForceMap(e:TimerEvent = null):void
		{
			forceMap.perlinNoise(forceMap.width, forceMap.height, 8, randomSeed, false, true, 1 + 2 + 4, false, offset);
			offset[0].x += 4;
			offset[0].y += 4;
			offset[1].x -= 2;
			offset[1].y -= 2;
			offset[2].x -= 8;
			offset[2].y -= 8;
			randomSeed = Math.floor(Math.random() * 0xFFFFFF);
		}
	}
}
